*         flp2_ASO_asm        
          nolist        
          section   AS
* 
          LEA       deftab(PC),A1
          MOVEA.W   $0110,A2            ; BP_INIT
          JSR       (A2)
          BRA       as_lnk
          dc.b      '.hpr91'
deftab    DC.W      6                   ; 6 proceduren
          DC.W      as_on-*
          DC.B      5,'AS_ON'           ; bildschirmkontrolle einschalten
          DC.W      as_off-*
          DC.B      6,'AS_OFF',0        ; dto. abschalten
          DC.W      as_set-*         
          DC.B      6,'AS_SET',0        ; intervall einstellen
          DC.W      as_lnk-*
          DC.B      6,'AS_LNK',0        ; interruptroutine einfgen
          DC.W      as_unlk-*
          DC.B      7,'AS_UNLK'         ; dto. wegnehmen
          DC.W      scn-*
          DC.B      3,'SCN'             ; programmiert bild ein/aus
          DC.W      0                   ; ende der procedurenliste
          DC.W      2                   ; 2 funktionen
          DC.W      tick-*
          DC.B      4,'TICK',0          ; uhr stellen, ret. sekunden
          DC.W      tick.s-*
          DC.B      5,'TICK$'           ; dto., ret abgelaufene uhrzeit
          DC.W      0                   ; ende der  funktionentabelle

* stand der uhr als string zurckgeben und ggf. uhr stellen
TICK.S    LEA       tik_cnt(PC),A0      ; zhler
          MOVE.L    (A0),D7             ; aktuellen stand holen
          BSR       prm_lint            ;> zahl hohlen
          BLE.S     tik_stg             ; ? kein neuer zhlerstand
          MOVE.L    D5,(A0)             ; stoppuhr stellen
tik_stg   MOVEQ     #18,D1              ; platz im ri-stack
          MOVEA.W   $011A,A2            ; mit BV_CHRIX reservieren
          JSR       (A2)                
          MOVEA.L   $58(A6),A4          ; obergrenze BV.RIP merken
          LEA       -18(A4),A1          ; aktuellen ri-stackpointer
          MOVE.L    A1,$58(A6)          ; im system fixieren
* D7.L 32 bit vorzeichenlos bewertet als string mit uhrzeitangabe an basic
          MOVE.L    D7,D5               ; zeit in sekunden
          MOVEQ     #0,D6               ; accu
          MOVEQ     #11,D1              ; len aus ziffern ohne markierungen
          MOVEQ     #'"',D3             ; '"' markierungszeichen
          MOVEQ     #50,D4              ; ticks je sekunde
          BSR.S     asci_num            ; 50stel sekunden in ASCII umsetzen
          MOVEQ     #':',D3           
          MOVEQ     #60,D4              ; 60 sekunden je minute
          BSR.S     asci_num            ; sekunden einsetzen
          MOVEQ     #$27,D3             ; ' markiert
          BSR.S     asci_num            ; minuten
          MOVEQ     #'h',D3             ; 'h'
          BSR.S     asci_num            ; stunden
          MOVEQ     #24,D4              ; 24 stunden pro tag
          MOVEQ     #'h',D3             ; 'd'
          BSR.S     asci_num            ; tage
          TST.W     D1                  ; restlnge 
          BMI.S     tik_xit             ; ? string vollgeschrieben
          MOVEQ     #$20,D3             ; mit leerzeichen
tik_fil   MOVE.B    D3,-1(A4,A6.L)      ;  string
          SUBQ.L    #1,A4               ;   am anfang
          DBF       D1,tik_fil          ;    auffllen
tik_xit   MOVE.W    #16,0(A1,A6.L)      ; Lnge eintragen
          MOVEQ     #1,D4               ; string-typ und
          MOVEQ     #0,D0               ;  fehlerfreien ablauf signalisieren
          RTS                           ; ret an basic

asci_num  BSR.S     div_lnum            ; D6.W = D5 mod D4, D5.L = D5 div D4
          MOVEQ     #1,D0
* so macht ganz flott und schwer durchschaubar minerva die zahl zum string 
asci_pak  DIVU      #10,D6              ; nach art des vectors cn.itod       
          SWAP      D6
          ROR.L     #1,D0               
          MOVE.B    D6,D0
          ROR.L     #4,D0               
          CLR.W     D6
          SWAP      D6
          BNE.S     asci_pak
asci_chr  ADDQ.B    #3,D0            
          ROL.L     #4,D0               ; 48 fr die '0' aus 3 * 2 ^ 4
          MOVE.B    D0,-(A7)            ; ascii.zeichen zwischenspeichern
          ADDQ.W    #1,D6               ; anzahl weiterzhlen
          CLR.B     D0
          ADD.L     D0,D0
          BCC.S     asci_chr            ; ? zeichen sind gepackt
          SUB.W     D6,D1               ; rest.len = max.len - ergebnis.len
          MOVE.B    D3,-1(A4,A6.L)      ; trennzeichen abliefern
          SUBQ.L    #1,A4               ; ptr und
          SUBQ.W    #1,D6               ;  zhler nachstellen
          MOVE.W    D6,D0               ; ergebnis.len merken
asci_put  MOVE.B    (A7)+,-1(A4,A6.L)   ; ziffern
          SUBQ.L    #1,A4               ; in den rckgabepuffer
          DBF       D6,asci_put
          TST.W     D0
          BNE.S     asci_xit            ; ? len ist > 1
          MOVE.B    #$20,-1(A4,A6.L)    ; sonst leerzeichen davorsetzen 
          SUBQ.L    #1,A4               ; adresse und
          SUBQ.W    #1,D1               ; rest.len anpassen
asci_xit  RTS

* vorzeichenlose division D5.L / D4.W => quotient D5.L rest D6.W
* ndert  d0, d5, d6          erhlt  d4
div_lnum  MOVE.W    D5,D6               ; lo.w merken
          CLR.W     D5                  ;  wegnehmen
          SWAP      D5                  ; hi.w frei zur division
          DIVU      D4,D5               ; d5.hi / d4
          MOVE.W    D5,D0               ; quotient.hi merken
          MOVE.W    D6,D5               ; zum rest.hi kommt d5.lo 
          DIVU      D4,D5               ; rest.hi.d5.lo / d4
          SWAP      D5                  ; quot.lo wegstecken
          MOVE.W    D5,D6               ; rest.lo ist divisionsrest
          MOVE.W    D0,D5               ; quotient hi.
          SWAP      D5                  ; hi.lo anordnung richtigstellen
          RTS

* zhlerstand in ticks ( je 20 ms ) zurckgeben und ggf. zhler stellen
TICK      LEA       tik_cnt(PC),A0
          MOVE.L    (A0),D7
          BSR.S     prm_lint
          BLE.S     d7fp_ret            ; ? nur den zhlerstand abliefern
          MOVE.L    D5,(A0)             ; zhler auch neu besetzen
* D7.L als f.p.-zahl normiert an basic zurckgeben
d7fp_ret  MOVE.W    D7,D4               ; f.p.-zahl D7 exponent
          MOVE.L    D7,D5               ; mantisse
          BEQ.S     d7fp_xit            ; ? null ist damit erledigt
d7fp_pos  MOVE.W    #$081F,D4           ; anfangs D7 ohne gebrochenen anteil
          ADD.L     D7,D7               ; Cy bit 31, V-flag bit 31 xor bit 30 
          BVS.S     d7fp_sgn            ; ? fertig bei vorzeichenwechsel
          SUBQ.W    #1,D4               ; exp an multiplikation anpassen
          MOVE.L    D7,D5               ; mit 2facher mnt weiterrechenen 
          MOVEQ     #16,D0              ; anfangswert entspr. 2^16
d7fp_nrm  MOVE.L    D5,D7               ; mantisse zur probe
          ASL.L     D0,D7               ; multiplikation 2^(D0)
          BVS.S     d7fp_nxt            ; ? irgendwo ein vorzeichenwechsel
          SUB.W     D0,D4               ; sonst division im exponenten
          MOVE.L    D7,D5               , und bernahme der mantisse
d7fp_nxt  ASR.W     #1,D0               ; nchster zhler mit halbem wert
          BNE.S     d7fp_nrm            ; ? solange noch zu zhlen ist
          BRA.S     d7fp_xit            ; normierung fertig
d7fp_sgn  BCC.S     d7fp_xit            ; ? 2^30-1 < zahl < 2^31
          ADDQ.W    #1,D4               ; exp * 2
          LSR.L     #1,D5               ; in mnt mit / 2 ausgleichen
d7fp_xit  MOVE.W    D4,-(A7)            ; weil man nie so genau wei, ob
          MOVE.L    D5,-(A7)            ; die roms die dokumentation kennen
          MOVEQ     #6,D1               ; 6 bytes fr f.p.-zahl 
          MOVEA.W   $011A,A2            ; mit BV_CHRIX
          JSR       (A2)                ;   reservieren
          SUBQ.L    #6,$58(A6)          ; bereich fixieren
          MOVEA.L   $58(A6),A1          ; ptr dorthin holen
          MOVE.L    (A7)+,2(A1,A6.L)    ; mantisse und
          MOVE.W    (A7)+,0(A1,A6.L)    ; exponenten eintragen
          MOVEQ     #2,D4               ; f.p.-typ signalisieren
          MOVEQ     #0,D0               ; ohne fehler
          RTS                           ; ret an basic

* alle angegebenen parameter als lange integer vom basic holen
* D5 erhlt ersten parm, der rest wird ohne fehlermeldung verworfen
* A0 wird konserviert, D5 kann mit vorgabe hereinkommen
prm_lint  MOVEQ     #-$12,D0            ; ERR_XP vorbereiten
          MOVEM.L   D5/A0,-(A7)         ; mitgegebene daten kellern
          CMPA.L    A3,A5               ; name-table prfen
          BLE.S     prm_xit             ; ? nichts bergeben
          MOVEA.W   $0118,A2            ; CA_GTLIN
          JSR       (A2)                ; alles als lange integer holen
          BNE.S     prm_rxit            ; ? oder mit fehlercode zurck
          TST.W     D3                  ; Anzahl Parameter
          BLE.S     prm_rxit            ; ? mit der vorgabe zurck
          MOVE.L    0(A1,A6.L),(A7)     ; erster parm ersetzt vorgabewert D5
          LSL.L     #2,D3               ; anzahl parm * 4
          ADD.L     D3,$58(A6)          ; bytes im ri-stack freigeben
prm_xit   ADDQ.L    #1,D0               ; fr einheitliche abfrage
prm_rxit  MOVEM.L   (A7)+,D5/A0         ; ohne fehler nur mit flags 'gt'
          RTS

* interrupt-routine zur bildabschaltung aktivieren   
AS_LNK    MOVEQ     #$1C,D0             ; MT_LPOLL
          LEA       int_exec(PC),A1     ; ausfhrungsadresse zum vergleich
lnk_unlk  LEA       int_link(PC),A0     ; link-adresse
          CMPA.L    4(A0),A1            ; vergleich soll-/ist-adresse
          BEQ.S     lnk_xit             ; ? operation wurde bereits erledigt
          MOVE.L    A1,4(A0)            ; ausfhrung angeben
          TRAP      #1                  ; nun erst listenoperation
lnk_xit   MOVEQ     #0,D0               ; immer ohne fehlermeldung
          RTS

* interruptroutine zur bildabschaltung wegnehmen
AS_UNLK   MOVEQ     #$1D,D0             ; MT_RPOLL
          SUBA.L    A1,A1               ; pseudo-ausfhrungsadresse
          BRA.S     lnk_unlk

* tastaturberwachung mit optionaler schaltzeitangabe aktivieren
AS_SET    LEA       key_set(PC),A0      ; vorgabeintervall
          MOVE.L    (A0)+,D5            ; bernehmen
          BSR.S     prm_lint            ; optionale eingabe
          BLT.S     ass_val             ; ? nicht angekommen
          NEG.L     D5                  ; schaltzeit zhlt aufwrts bis 0
          BCLR      #$1F,D5             ; und max. 2^30 pulse
ass_val   MOVE.L    D5,(A0)             ; schaltzeitangabe eintragen
          BRA.S     aso_ntry            ; weiter zum setzen des zhlers

* tastaturberwachung aktivieren
AS_ON     LEA       key_val(PC),A0      ; schaltzeit
aso_ntry  MOVE.L    (A0)+,(A0)          ; in den zhler setzen
          BRA.S     aso_xit             ; ret ohne fehler

*  tastaturberwachung suspendieren
AS_OFF    LEA       key_cnt(PC),A0      ; zhler
          CLR.L     (A0)                ; inaktiv schalten
          BRA.S     aso_xit             ; ret ohne fehler

* bild timer-unabhngig aus tastatur oder programmgesteuert schalten:
* Aufruf ohne parm oder mit parm =/= 0 schaltet bild ein  
*       parm undefiniert oder parm = 0 sachaltet bild aus
SCN       MOVEQ     #2,D7               ; bild aus vorbereiten
          CMPA.L    A3,A5
          BLE.S     scn_set             ; ? ohne parm einschalten
          BSR.S     prm_lint            ; zahl holen
          BLE.S     scn_xit             ; ? bei undefinierter zahl ausschalten
          TST.L     D5
          BEQ.S     scn_xit             ; ? bild aus bei parm = 0
scn_set   MOVEQ     #0,D0               ; MT_INF fr die
          TRAP      #1                  ;  basis der systemvariablen
          MOVE.B    $34(A0),D7          ; SV_MCSTA
          ANDI.B    #$FD,D7             ; reset bit 1 zum einschalten
scn_xit   MOVE.B    D7,$018063          ; MC.STAT
aso_xit   MOVEQ     #0,D0               ; ret ohne fehler
          RTS

* interrupt-aufruf mindest-ausfhrungsdauer ;138; Takte ( ca. 18 s )
* bei eingeschaltetem timer, aber inaktiver tastaturberwachung
* register bei aufruf   a6 sysbase
int_exec  LEA       tik_cnt(PC),A2      ;16; timer
          ADDQ.L    #1,(A2)             ;40;  weiterzhlen
          MOVEQ     #0,D0               ;08: MT_INF oder ret ohne fehler
          TST.L     -(A2)               ;24; schaltzeit
          BEQ.S     int_ret             ;18; ? zhler inaktiv
*          TRAP      #1                  ;    mt.inf ausfhren
          MOVEQ     #17,D0              ;    MT_IPCOM
          LEA       ipc_parm(PC),A3
          TRAP      #1
          MOVEQ     #0,D0               ;    rckkehr immer ohne fehler
          BTST      #0,D1
          BNE.S     mcs_on              ;    ? tastatur bettigt
          TST.L     (A2)
          BMI.S     mcs_off             ;    ? schaltzeit abgelaufen
          ADDQ.L    #1,(A2)             ;    sonst weiterzhlen
int_ret   RTS                           ;32;

mcs_on    MOVE.B    $34(A6),D2          ; mit SV.MCSTA bild einschalten
          BRA.S     mcs_set
mcs_off   MOVEQ     #2,D2               ; bild abschalten
mcs_set   MOVE.B    D2,$018063          ; MC.STAT
          MOVE.L    -4(A2),(A2)         ; schaltzeit auf gesetzten wert
          RTS
          
ipc_parm  DC.B      1,0                 ; STAT.CMD, keine parm
          DC.L      0                   ; nichts senden
          DC.B      2,0                 ; 8 bit antwort, adressenausgleich

int_link  DC.L      0                   ; link fr poll-interrupt
          DC.L      0                   ; interruptroutine
key_set   DC.L      $7FFFC568           ; schaltzeitvorgabe
key_val   DC.L      1                   ; schaltzeit aus parm oder vorgabe
key_cnt   DC.L      0                   ; tastaturberwachung
tik_cnt   DC.L      0                   ; timer 

          END
