*
* Ohne Ergnzungen geeignet fr den GST-Assembler. - .hpr'92
*
* Adaption von
*       Adrian Dickens' Self Cloning Program
*
* Fehlerhafte Fehlercodierung (3/92):
* Minerva (1.91) ohne Meldung bei Bereichsberschreitung in SD.FILL.
*
          nolist
*
jb.a7     equ       $5c                 ; ablage A7 im jcb
mt.activ  equ       $0a                 ; latenten job aktivieren
mt.cjob   equ       1                   ; code die jobverwaltung aufnehmen
mt.frjob  equ       5                   ; einen jobzweig unbedingt lschen
mt.inf    equ       0                   ; basis der systemvariablen
mt.ipcom  equ       $11                 ; piepsen
mt.prior  equ       $0b                 ; prioritt setzen, adr des jcb holen
mt.rjob   equ       4                   ; ruhenden job entfernen
mt.susjb  equ       8                   ; job suspendieren
sd.clear  equ       $20                 ; fensterinhalt lschen
sd.fill   equ       $2e                 ; wie basic BLOCK
self      equ       -1                  ; der aufrufende job
sv.rand   equ       $2e                 ; adr einer 16-bit zufallszahl
.scr      setstr    con_512x256a0x0_2   ; das arbeitsfenster ('CON' wegen pif)
.lscr     setnum    [.LEN(.scr)]        ; lnge des string
*
          section   MCLONE
          data      256
*
* Hier kommt der Aufruf aus EXEC o.dgl. an.     
          bra.s     mclone              ; sprung in den job
          ds.l      1                   ; 6 bytes sind einzuhalten      
          dc.w      $4afb,6,'MClone'    ; der standardheader
          ds.w      0                   ; ausgleich auf gerade adresse
*
* Name fr das Arbeitsfenster zum IO.OPEN-Aufruf.
scr       dc.w      [.lscr],'[.scr]'    ; text fr den fensterkanal
          ds.l      0                   ; adressen justieren
*
* Parameter fr MT.IPCOM zum Piepsen auf gerader Adresse.
piep      dc.b      10,8                ; tongenerator, 8 parameter
          dc.l      %11111111111111111010101010101010 ;   volstndig senden
          dc.b      2,90                ; beide tne
          dc.b      255,0               ; 255 ticks (je 75s) stufung
          dc.w      32                  ; 8K ticks dauer
          dc.b      83                  ; tonstufung 5, wiederholung 3
          dc.b      0                   ; ohne zufallsmll
          dc.b      %00000001           ; keine antwort
          ds.l      0                   ; adressen justieren
ruhe      dc.b      11,0                ; tongenerator abschalten
          dc.l      -1                  ; keine parameter
          dc.b      1                   ; nichts empfangen
          ds.l      0
ipcom     dc.b      1,0                 ; status abfragen
          dc.l      -1
          dc.b      2                   ; ein antwortbyte
          ds.l      0
*
* Dieser Teil baut die Umgebung auf, aus der heraus die Clones entstehen.
mclone    lea       scr(pc),a0          ; arbeitsfenster
          moveq     #0,d3               ; einfach OPEN
          moveq     #self,d1            ; fr den eigenen job
          moveq     #1,d0               ; io.open
          trap      #2                  ; fenster aufmachen
          tst.l     d0                  ; bei fehler
          bne.s     kill_jb             ; ? aufgeben
          moveq     #sd.clear,d0        ; bild lschen
          moveq     #0,d3               ; nicht warten
          trap      #3                  ; kanal-id ist in A0
*** Fr das pif kann noch die generelle Fenster-Freigabe eingefgt werden:
*          moveq     #124,d0             ; io.pick
*          moveq     #0,d3               ; auch secundrfenster
*          moveq     #-2,d1              ; nicht verriegelbar
*          trap      #3                  ; fehler egal (-15 ohne pif)
          move.l    #$00fe003f,d4       ; {x,y} beginnt in der mitte (mode 8)
          move.l    a0,a4               ; kanal bereitstellen
          bsr.s     crea_jb             ;>> vermehrung einleiten
          move.l    d1,d6               ; neue job-id merken
*
* In diesem privaten Scheduler wird geprft, ob alle Jobs des Zweiges
* inaktiv geworden sind. Ist das der Fall, wird das Programm beendet.
kill_jb   moveq     #50,d3              ; fr 1 sec
          moveq     #mt.susjb,d0        ; zuerst
          moveq     #self,d1            ; eigenen job
          sub.l     a1,a1               ; ohne flag
          trap      #1                  ; suspendieren
          moveq     #mt.rjob,d0         ; nun inaktiven job
          move.l    d6,d1               ; mit seinen nachkommen
          trap      #1                  ; wegnehmen
          tst.l     d0                  ; gelungen oder
          bne.s     kill_jb             ; ? erneute prfung
*
* Erst, wenn kein Clone mehr aktiv ist, wird die Kette aufgelst.
          bsr.s     quietsch            ;> etwas gerusch
stille    lea       ipcom(pc),a3        ; am ende
          moveq     #mt.ipcom,d0        ; warten bis die piepserei 
          trap      #1                  ; aufgehrt hat, damit
          and.b     #2,d1               ; der ipc nicht den boden verliert
          bne.s     stille              ; ? ist's noch nicht
          movem.l   a3/a6,-(sp)         ; irgendwelche farben
          move.l    sp,a1
          move.l    a4,a0
          moveq     #0,d3
          moveq     #38,d0              ; sd.recol zeigt das ende an
          trap      #3
          moveq     #mt.frjob,d0        ; dann 'force remove':
          moveq     #self,d1
          moveq     #0,d3
          trap      #1                  ; ende ohne wiederkehr

quietsch  lea       ruhe(pc),a3         ; erstmal
          moveq     #mt.ipcom,d0        ; alten krach
          trap      #1                  ; unterbinden
          lea       piep(pc),a3         ; dann quietscht
          moveq     #mt.ipcom,d0        ; ein ton
          trap      #1
          rts
*
* Aufbau eines Clone einleitend einmal, und dann jeweils aus den daraus
* eingerichteten Clones. Diese erhalten hier ihre Gestalt als Job nach
* Einrichten eines Definitionsblocks und Zuweisung von 36 Speicherbytes.
* der Aufruf darin fhrt nach dem eigentlich arbeitenden Codeteil SCLONE. 
*
* datenbergabe:   {d4} Startpunkt im bild   a0 id des hauptfensters
* zunchst wird nur das vorhandensein eines jobs angemeldet
crea_jb   moveq     #mt.cjob,d0         ; einen job bauen
          moveq     #self,d1            ; vaterschaft
          moveq     #16,d2              ; codebereich
          moveq     #20,d3              ; datenbereich
          sub.l     a1,a1               ; keine startadresse
***          lea       sclone(pc),a1       ; oder doch, aber erst ab JS-Rom !
          trap      #1                  ; d1 wird job-id
          tst.l     d0                  ; einrichten
          bne.s     cr_exit             ; ? nicht gelungen
          move.l    a0,a6               ; basis des speicherbereichs
*
* Aufbau eines Jobheaders mit der Arbeitsadresse am Anfang:
*
* Bei Angabe einer Startadresse mit mt.cjob steht anfangs gleich RTS:
***          move.w    #$4e75,(a6)+        ; sonst gibt es einen Sprung
***          lea       quietsch(pc),a1     ; in irgendeine Startroutine.
* Gewhnlich wird der Sprung in den eigentlichen Code eingetragen.
          move.w    #$4ef9,(a6)+        ; JMP.L
          lea       sclone(pc),a1       ;  nach
          move.l    a1,(a6)+            ;   SCLONE.
          move.l    #$4afb0006,(a6)+    ;     es ist ein Job mit
          move.w    #'SC',(a6)+         ;      einem
          move.l    #'lone',(a6)        ;         namen.
*
* Der Datenbereich erhlt im Stack die Angaben zu Kanal und Bildkoordinaten.
          lea       34(a0),a6           ; stack einrichten
          move.l    #$01ff00ff,d0       ; koordinaten begrenzen
          and.l     d4,d0               ; nur fr den neuen job
          move.l    d0,-(a6)            ; {x,y} startpunkt ablegen
          move.w    #4,-(a6)            ; mitteilung ist 4 bytes lang
          move.l    a4,-(a6)            ; ID fr
          move.w    #1,-(a6)            ;  einen kanal
*
* Noch ruht der Job. Hier geht es erst noch in den jcb, damit der dort
* gltige Stackpointer die richtige Adresse erhlt.
          moveq     #mt.prior,d0        ; hilfsweise
          moveq     #0,d2               ;  prioritt setzen
          trap      #1                  ;   fr die jobbasis a0
          move.l    a6,jb.a7(a0)        ; dort den stackptr setzen
*
* Jetzt kann der neue Job die Arbeit aufnehmen.
          moveq     #mt.activ,d0        ; alles ist eingerichtet
          moveq     #1,d2               ; und wird mit prioritt 1
          moveq     #0,d3               ; gemeinsam mit anderen jobs
          trap      #1                  ; aktiviert (entspr. EXEC)
          tst.l     d0
cr_exit   rts                           ; ret mit job-id in d1
*
* Dieser Programmcode wird von allen aktiven Clones gemeinsam benutzt.
sclone    moveq     #mt.inf,d0
          trap      #1                  ; sysbase holen
          move.l    a0,a2               ; sichern
          addq.l    #2,a7               ; bergebene kanal-anzahl ist bekannt
          move.l    (a7)+,a4            ; kanal-id
          addq.l    #2,a7               ; bergebene byte-anzahl ist bekannt
          move.l    (a7),d4             ; {x,y} bildpunkt
          move.l    #$00060004,-(a7)    ; block 6x4
          move.l    a7,a5               ; datenbereich fr BLOCK-parameter
          moveq     #0,d6               ; register ganz freimachen
          move.w    sv.rand(a0),d6      ; zufallszahl vom system
          move.l    d6,d5               ; copie zum rechnen
          ror.w     #2,d6               ; damit ms.byte sich schneller ndert
          move.w    d6,d7               ; y-sprungweite
          ror.w     #4,d6               ; x-sprungweite
          eor.w     d6,sv.rand(a0)      ; systemzahl erneuern
          moveq     #0,d1               ; register ganz lschen 
          move.b    d7,d1               ; farbe aus y-wert
          eor.b     d6,d1               ;  =/= y
          moveq     #13,d5
          lsr.w     d5,d6               ; abs(x-stufe) 1 bis 4 und hi.byte leer
          bne.s     kord_y
          moveq     #-1,d6
kord_y    lsr.w     d5,d7               ; y dto.
          bne.s     kord_psh
          moveq     #1,d7
kord_psh  move.w    d7,-(a7)            ; koordinaten
          move.w    d6,-(a7)            ;  kellern
          move.w    d4,d5               ; y anfangspunkt
          swap      d4                  ; x
          move.b    d1,d6               ; ink sichern
set_loop  moveq     #19,d7              ; 20 kltzer zwischen den clones
loop      add.w     (a7),d4             ; berlauf in die koordinaten
          add.w     2(a7),d5            ; betrag hineinaddieren
* Hier knnte man noch mit den Koordinaten herumspielen...
          movem.w   d4-d5,4(a5)         ; koordinaten in den datenbereich
          bsr.s     wblob               ; einen klotz ins bild setzen
          bne.s     done                ; ? ende am bildrand oder bei fehler
          cmp.w     #$104,d5            ; y-wert nochmals prfen, denn
          bhi.s     done                ; minerva macht fehler beim fehler
          moveq     #mt.susjb,d0        ; ruhigstellen
          moveq     #self,d1            ; des jobs
          moveq     #10,d3              ; fr einige ticks
          sub.l     a1,a1               ; kein flag-byte
          trap      #1
          dbra      d7,loop             ; malen
          bsr       crea_jb             ;> bei gelungener vermehrung
          bra.s     set_loop            ; weiter so
*
done      bsr       quietsch
          moveq     #mt.prior,d0        ; vermehrungsvorgang
          moveq     #self,d1            ; fr diesen job
          moveq     #0,d2               ; durch inaktivieren
          trap      #1                  ; unterbinden
*
* Wenn hier ein Fehler auftritt, wird der Job beendet:
* err.bo kommt zurck, wenn der Fensterrand berhrt wird,
* (Minerva ist hier wieder besonders clever und gibt keine Meldung)
* err.nc z.b., wenn das Bild eines anderen Jobs aktiviert wurde.
* Die meisten Farbwerte fr schwarz werden abgefangen. 
wblob     move.l    d6,d1               ; farbe fr ink
          bsr.s     wbl_chk             ;> schwarz herausfinden
          bne.s     wbl_ink             ; ? ist angegeben
wbl_col   moveq     #6,d1
          and.b     1+sv.rand(a2),d1    ; sonst zufallszahl nehmen
          bsr.s     wbl_chk             ;> schwarz herausfinden
          bne.s     wbl_ink             ; ? ist angegeben
          moveq     #19,d0              ; wenigstens mt.rclk
          trap      #1                  ; sollte nicht null sein
          bsr.s     wbl_chk             ;> schwarz herausfinden
          bne.s     wbl_ink             ; ? ist angegeben
          moveq     #7,d1               ; bleibt vorlufig nur wei
wbl_ink   move.b    d1,d6               ; farbwert verankern
          moveq     #0,d3               ; nicht warten    
          move.l    a4,a0               ; fensterkanal-id
          moveq     #sd.fill,d0         ; einen klotz zeichnen
          move.l    a5,a1               ; parameterblock
          trap      #3                  ; block ausmalen
          tst.l     d0                  ; ergebnis melden
          rts

wbl_chk   moveq     #6,d0               ; muster und hintergrund egnehmen
          and.b     d1,d0
          beq.s     wbl_crt             ; ? kann schwarz sein
          moveq     #56,d2
          and.b     d1,d2
          asr.b     #3,d2               ; hintergrund
          and.b     d2,d0               ; mit farbe maskiert
wbl_crt   rts

          END

